"""
Tester classes for creating custom testers for the classification
"""


class ModelTester(object):
    """
    Abstract class for model testing
    """

    def __iter__(self):
        """
        Is necessary for the iterator functionality

        :return: The object itself as iterator object
        """
        return self

    def __next__(self):
        """
        Implements the iterator functionality to get the next test data

        :return: The next test data object, that is generated by next_test_data method
        """
        return self.next_test_data()

    def next_test_data(self):
        """
        Abstract method, that should generate the next test data, which will be processed by a feature extractor and
        afterwards predicted by a classifier

        :return: Next test data object
        """
        raise NotImplementedError("must be implemented in subclasses")

    def store_part_test_prediction(self, classification, confidence):
        """
        Abstract method, that should handle the results of the classifier prediction

        :param classification: Classification results for the generated test data object
        :type classification: numpy.ndarray
        :param confidence: Confidence scores for the corresponding classes if this functionality is available on the
        classifier
        :type confidence: numpy.ndarray
        :return:
        """
        raise NotImplementedError("must be implemented in subclasses")

    def store_test_results(self):
        """
        Method that will be called after the full test is executed. Method can persist the test results.
        """
        raise NotImplementedError("must be implemented in subclasses")
